#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
#-----------------------------------------------------------------------------
Name		:	p11-kit
Version		:	0.25.5
Release		:	17.0.10.rel%{?dist}
Summary		:	Provides a way to load and enumerate PKCS #11
Group		:	Development/Tools

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	GPLv2+ and LGPLv2+ and GFDL
URL		:	https://p11-glue.github.io/p11-glue/p11-kit.html
			# https://github.com/p11-glue/p11-kit

Source0		:	%{name}-%{version}.tar.xz
#-----------------------------------------------------------------------------
BuildRequires	:	bash-completion
BuildRequires	:	gcc
BuildRequires	:	gettext
BuildRequires	:	gtk-doc
BuildRequires	:	libtasn1-devel
BuildRequires	:	libxslt
BuildRequires	:	libffi-devel

Requires	:	nss
Requires	:	make-ca
#-----------------------------------------------------------------------------
%description
Provides a way to load and enumerate PKCS#11 modules. Provides a standard
configuration setup for installing PKCS#11 modules in such a way that they're
discoverable.

Also solves problems with coordinating the use of PKCS#11 by different
components or libraries living in the same process.

#-----------------------------------------------------------------------------
%files			-f %{name}.lang
%defattr(-,root,root,-)
%doc AUTHORS COPYING NEWS README
%{_sysconfdir}/pkcs11/pkcs11.conf.example
%{_bindir}/%{name}
%{_libdir}/%{name}-proxy.so
%{_libdir}/lib%{name}.so.*
%{_libdir}/pkcs11/%{name}-client.so
%{_libexecdir}/p11-kit/p11-kit-remote
%{_libexecdir}/p11-kit/p11-kit-server
%{_datadir}/bash-completion/completions/p11-kit
%{_mandir}/man8/p11-kit.8.gz
%{_mandir}/man5/pkcs11.conf.5.gz

#=============================================================================
%package		devel
Summary		:	Development files for %{name}

#-----------------------------------------------------------------------------
Requires	:	%{name}		= %{version}-%{release}

#-----------------------------------------------------------------------------
%description		devel
The %{name}-devel package contains libraries
and header files for developing applications
that use %{name}.

#-----------------------------------------------------------------------------
%files			devel
%defattr(-,root,root,-)
%{_includedir}/%{name}-1/%{name}/*.h
%{_libdir}/lib%{name}.so
%{_libdir}/pkgconfig/%{name}-1.pc
%{_datadir}/gtk-doc/html/%{name}/*.{html,png}
%{_datadir}/gtk-doc/html/%{name}/style.css

#=============================================================================
%package		trust
Summary		:	System trust module from %{name}

#-----------------------------------------------------------------------------
Requires	:	%{name}		= %{version}-%{release}
Requires(post)	:	nss
Requires(post)	:	coreutils

#-----------------------------------------------------------------------------
%description		trust
The %{name}-trust package contains a system trust
PKCS#11 module which contains certificate anchors and black lists.

#-----------------------------------------------------------------------------
%files			trust
%defattr(-,root,root,-)
%{_bindir}/trust
%{_libdir}/pkcs11/%{name}-trust.so
%{_libdir}/libnssckbi.so
%{_bindir}/update-ca-certificates
%{_libexecdir}/%{name}/trust-extract-compat
%{_datadir}/%{name}/modules/%{name}-trust.module
%{_datadir}/bash-completion/completions/trust
%{_mandir}/man1/trust.1.gz

#=============================================================================
%prep
%setup -q

#-----------------------------------------------------------------------------
#building application
%build

sed -i							\
  -e '20,$ d'						\
  trust/trust-extract-compat

cat >> trust/trust-extract-compat << "EOF"
# Copy existing anchor modifications to /etc/ssl/local
/usr/libexec/make-ca/copy-trust-modifications

# Generate a new trust store
/usr/sbin/make-ca -f -g
EOF

%{__mkdir_p}  p11-build
pushd p11-build

meson							\
        --prefix=%{_prefix}				\
	--includedir=%{_includedir}			\
	--sysconfdir=%{_sysconfdir}			\
	--libdir=%{_libdir}				\
	--libexecdir=%{_libexecdir}			\
        --sbindir=%{_sbindir}				\
	--mandir=%{_mandir}				\
	--infodir=%{_infodir}				\
	--sharedstatedir=%{_var}/lib			\
	--buildtype=release				\
	-D gtk_doc=true					\
	-D nls=true					\
	-D systemd=disabled				\
	-D bash_completion=enabled			\
	-D gtk_doc=true					\
	-D man=true					\
	-D trust_paths=%{_sysconfdir}/pki/anchors	\

%define _smp_mflags -j%(/usr/bin/getconf _NPROCESSORS_ONLN)
ninja -v -k1 %{_smp_mflags}
popd

#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
#installing program
%install
%{__rm} -rf %{buildroot}

pushd p11-build
DESTDIR=%{buildroot}					\
	ninja install
popd 

%{__ln_s}						\
	../libexec/%{name}/trust-extract-compat		\
	%{buildroot}%{_bindir}/update-ca-certificates

%{__ln_s}						\
	./pkcs11/%{name}-trust.so			\
	%{buildroot}%{_libdir}/libnssckbi.so

#To remove libtool library
find 							\
	%{buildroot}%{_libdir}				\
	-name \*.la					\
	-delete

%find_lang %{name}
#-----------------------------------------------------------------------------
%changelog
